from flask import Flask, request, jsonify

import requests
import json
import datetime

EEST = datetime.timezone(datetime.timedelta(hours=3))

app = Flask(__name__)


def fetch_price_from_history_server(day):

    # Fetch price data from the history server microservice using GET request
    price_json = 

    return(price_json)


def calculate_best_price(window_size, prices):
    start_hour = ""
    end_hour = ""
    best_price = 0

    # Find the cheapest window_size length period in the prices list


    # Output the total price of the time period of window_size length together with starting time and ending time when to turn on device.
    return(
        {
          "start-time": start_hour,
          "end-time": end_hour,
          "total-price": best_price
        }
    )




@app.route("/optimal-prices", methods=['GET'])
def get_optimal_prices():
    # An example API request: http://app-server/api/optimal-prices?length=3&day=2024-10-14

    # Electricity usage period length in hours  
    length = request.args["length"]
    
    # For which day we want to find the optimal price? Typically tomorrow or today, but this value comes from the API client.  
    day = request.args["day"]
    
    # Fetch the prices for a specific day from the history server
    json_prices = fetch_price_from_history_server(day)

    # Calculate the 
    recommendation = calculate_best_price(length, json_prices)

    return(recommendation, 200)


@app.route("/health", methods=['GET'])
def health():
    response = "Application is working properly!"
    return response, 200
    

if __name__ == "__main__":
    app.run(host="0.0.0.0", port=5000)

